
if exists (select * from sysobjects where id = object_id(N'[dbo].[Trig_Parent_Upd]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[Trig_Parent_Upd]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[Trig_Parent_Del]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[Trig_Parent_Del]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[child]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[child]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[dummy]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[dummy]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[Parent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Parent]
GO

CREATE TABLE [dbo].[child] (
	[Sysid] [int] IDENTITY (1, 1) NOT NULL ,
	[ParSysid] [int] NOT NULL ,
	[ChiName] [char] (10) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[dummy] (
	[dummy_col] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Parent] (
	[SysId] [int] IDENTITY (1, 1) NOT NULL ,
	[ParName] [char] (10) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[child] WITH NOCHECK ADD 
	CONSTRAINT [PK_child] PRIMARY KEY  NONCLUSTERED 
	(
		[Sysid]
	)  ON [PRIMARY] ,
	CONSTRAINT [K_child] UNIQUE  NONCLUSTERED 
	(
		[ParSysid],
		[ChiName],
		[Sysid]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Parent] WITH NOCHECK ADD 
	CONSTRAINT [PK_Parent] PRIMARY KEY  NONCLUSTERED 
	(
		[SysId]
	)  ON [PRIMARY] 
GO


SET QUOTED_IDENTIFIER  ON    SET ANSI_NULLS  ON 
GO

CREATE TRIGGER Trig_Parent_Upd  ON dbo.Parent
FOR  UPDATE 
AS
  If Update(Sysid) 
    Update child set ParSysid = P.Sysid 
       From child c, Parent p, deleted d 
       where exists( select * from deleted where d.sysid = c.ParSysid)

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  ON    SET ANSI_NULLS  ON 
GO

CREATE TRIGGER Trig_Parent_Del ON dbo.Parent
FOR DELETE 
AS
/*  Cascade 
Delete Child from child c, deleted d where 
    exists( select * from deleted where c.parsysid = d.sysid) */
/* Restrict */
IF exists(select * from child c, deleted d where 
  exists(select * from deleted d where c.ParSysid = d.Sysid)) 
BEGIN
	RAISERROR ('You man not delete a Parent with Children.', 16, 1)
	ROLLBACK TRANSACTION
END

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

